=== debian/changelog ===
pupnp (1:1.18.0-1) experimental; urgency=medium

  * New upstream version 1.18.0
  * SONAME bump: libupnp17 -> libupnp20
  * debian/copyright:
    - Update copyright years
    - Remove FSF address
  * debian/control:
    - Bump Standards-Version
    - Drop RRR: no
    - Drop Priority: optional

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 11 Feb 2026 18:57:44 +0100
