=== debian/watch ===
Version: 5

Template: GitHub
Owner: pupnp
Project: pupnp
